/***********************************
 Computer Master Mind
 Computer adaptation by Dave Spady
 Computer Adaptation Copyright David Spady

 Send Comments to D. Spady (72767, 4362) or
 176 Quesnell Crescent
 Edmonton, Alberta, Canada
 T5R-5P3
************************************/

#include <time.h>         // for randomize()
#include <stdlib.h>       // for randomize()
#include <conio.h>        // for text display functions
#include <string.h>       // for strlen()
#include <process.h>
#include <stdio.h>
#include <dos.h>          // for delay()
#define TITLE_LENGTH  20  // maximum length of textbox title
#define TEXT_LENGTH   80  // maximum length of textbox text

void options(void);
void show_aboutbox(void);
void show_instructions(void);
char get_code(void);
int verify_move(int turns);
void display(int turns, int colour[10], int y);
void make_move(int turns);
void make_textbox(struct textbox);
void draw_box(int left, int top, int width, int height);

struct textbox
   {
   int left;                    // left
   int top;                     // top
   int width;                   // width
   int height;                  // height
   int backclr;
   int textclr;
   char title[TITLE_LENGTH+1];  // title
   char text[TEXT_LENGTH+1];    // text
   };

int GoneToOpt = 0;
int restart = 0;
int colour[10];
int colourkey[10];
int why, whx;
int buff[80][25];
int num_pegs;
int global_pegs = 4;
int num_colours;
int global_colours = 6;

   struct textbox Options = { 5, 14, 15, 3, WHITE, BLUE, "","(O)ptions" };

void main(void)
   {
   char ans;
   int won;
   int turns;
   int x;
   gettext(1,1,80,25,buff);
   whx = wherex();
   why = wherey();

   struct textbox Instruct = {5, 2, 15, 3, WHITE, BLUE, "", "(H)ow to play"};
   struct textbox Done = { 5, 6, 15, 3, WHITE, BLUE, "","(R)estart" };
   struct textbox Quit = { 5, 10, 15, 3, WHITE, BLUE, "","(Q)uit Game" };


   _setcursortype(_NOCURSOR);
   do
   {
   won = 0;
   restart = 0;
   num_colours = global_colours;
   num_pegs = global_pegs;
   struct textbox gamebox =  { 25, 2, 10+num_pegs*(5-1), 22, BLACK, YELLOW, " (M)aster Mind ",
			       "" };

   struct textbox Won  = { 54+(num_pegs-4)*3, 2, 20, 3, BLACK, YELLOW, "", "You Won!"};
   struct textbox Lost  = { 54+(num_pegs-4)*3, 2, 20, 3, BLACK, YELLOW, "", "You Lost"};
   struct textbox Play_Again = { 54+(num_pegs-4)*3, 6, 20, 3, BLACK, YELLOW, "", "Play Again? (y/n) "};


   randomize();
   for(x=0;x<num_pegs;x++) colour[x] = 1;
   for (x=0;x<num_pegs;x++) colourkey[x] = random(num_colours);
   textbackground(BLUE);
   clrscr();
   make_textbox(gamebox);
   make_textbox(Instruct);
   make_textbox(Done);
   make_textbox(Quit);
   make_textbox(Options);
   textbackground(BLACK);
   textcolor(CYAN);
   gotoxy(27,4);
   cputs("K E Y \x1A");
   textcolor(WHITE);
   for (x=0;x<num_pegs;x++)
       {
       gotoxy(35+x*4,4);
       cputs("\xB2\xB2");
       delay(100);
       }
   for(turns=10;turns>1;turns--)
     {
     if (restart == 1) break;
     GoneToOpt = 0;
     make_move(turns);
     if (GoneToOpt == 0) won = verify_move(turns);
     else{turns++;}
     if (won == 1) break;
     }
   if (restart != 1)
   {
     if (won==1)
     {
       for (x=0;x<num_pegs;x++)
	 {
	 textcolor(colourkey[x]+8);
	 gotoxy(35+x*4,4);
	 cputs("\xDB\xDB");
	 delay(100);
	 }
     make_textbox(Won);
     }
     else
     {
     for (x=0;x<num_pegs;x++)
       {
       textcolor(colourkey[x]+8);
       gotoxy(35+x*4,4);
       cputs("\xDB\xDB");
       delay(100);
       }
     make_textbox(Lost);
     }
   }
   if (restart == 1) ans = 'y';
   else
   {
   make_textbox(Play_Again);
   do ans = getch();
   while (ans !='y' && ans != 'n' && ans != 'Y' && ans != 'N');
   }
   for(x=0;x<num_pegs;x++) colour[x] = 1;
   }
   while (ans == 'y' || ans == 'Y');

   _setcursortype(_NORMALCURSOR);
   puttext(1,1,80,25,buff);
   gotoxy(whx,why);
   }

// make_textbox()
// draws textbox with title and text
void make_textbox(struct textbox box)
   {
   textbackground(box.backclr);
   textcolor(box.textclr);
   draw_box(box.left, box.top, box.width, box.height);

   gotoxy(box.left+(box.width-strlen(box.title))/2, box.top);
   cputs(box.title);
   window(1,1,80,25);
   gotoxy(box.left+(box.width-strlen(box.text))/2,
				     box.top+(box.height-1)/2);
   cputs(box.text);
   }

// draw_box()
// draws a box with a single line around it
void draw_box(int left, int top, int width, int height)
   {
   int j;
   char string[81];           // utility string

   window(left, top, left+width-1, top+height-1);
   clrscr();
   window(left, top, left+width-1, top+height);
   for(j=1; j<width-1; j++)   // make string of
      string[j] = '\xC4';     //    horizontal characters
   string[width] = '\0';      // end the string
   string[0] = '\xDA';        // insert upper left corner
   string[width-1] = '\xBF';  // insert upper right corner
   gotoxy(1, 1);              // display top line
   cputs(string);
   string[0] = '\xC0';        // insert lower left corner
   string[width-1] = '\xD9';  // insert lower right corner
   gotoxy(1, height);         // display bottom line
   cputs(string);
   // draw vertical lines on left and right
   for(j=2; j<height; j++)    // for each row
      {
      gotoxy(1, j);           // on the left end,
      putch('\xB3');          // draw vertical character
      gotoxy(width, j);       // on the right end,
      putch('\xB3');          // draw vertical character
      }
   window(1,1,80,25);
   }

void make_move(int turns)
  {
  char ch;
  int x;
  int y;

  textbackground(BLACK);
  y = 0;
  ch = ' ';
  display(turns,colour,y);
  while ( ch != 'd' )
    {
    ch = get_code();
    if (ch == 'd')
      {
      y = 6;
      display(turns, colour,y);
      break;
      }
    switch ( ch )
      {
      case 77: // RIGHT ARROW
	y=(y<num_pegs-1) ? ++y: 0;
	break;
      case 75: // LEFT ARROW
	y=(y>0) ? --y : num_pegs-1;
	break;
      case 72: // UP ARROW
	colour[y] = (colour[y]>0) ? --colour[y] : num_colours-1;
	break;
      case 80: // DOWN ARROW
	colour[y] = (colour[y]<num_colours-1) ? ++colour[y] : 0;
	break;
      default:
	;
      }
      display(turns,colour,y);
    }
  }

void display(int turns, int colour[], int y)
  {
  int x;
  for(x=0;x<num_pegs;x++)
    {
    gotoxy(35+x*4,turns*2+2);
    textcolor(colour[x]+8);
    if (x==y)
      cputs("\xB2\xB2");
    else
      cputs("\xDB\xDB");
    }
  }

char get_code(void)
  {
  char key;
  int buff2[80][25];

  key = getch();
  if (key == '\r') return ('d');
  if (key == 'r'|| key == 'R')
  {
    restart = 1;
    return('d');
  }
  if (key == 'o'|| key == 'O')
  {
  options();
  return('d');
  }
  if (key =='q'||key == 'Q')
    {
    puttext(1,1,80,25,buff);
    gotoxy(whx,why);
    exit(0);
    }
  if (key == 'm'||key == 'M') show_aboutbox();
  if (key == 'h'|| key == 'H') show_instructions();
  if (key == 0)
    return(getch());
  else
    return(0);
  }

int verify_move(int turns)
  {
  int Won = 0;
  int x,y;
  int B_peg = 0, W_peg = 0;
  int flag[10];
  int Whiteflag[10];

  for (x=0;x<10;x++) {flag[x] = 0;Whiteflag[x]=0;}

  for (x=0;x<num_pegs;x++)  // searching for black pegs
    {
    if (colour[x] == colourkey[x])
      {
      B_peg++;
      flag[x] = 1;
      }
    }

  for (x=0;x<num_pegs;x++)
    {
    if (flag[x] == 1) continue;
    for (y=0;y<num_pegs;y++)
      {
      if (flag[y] == 1) continue;
      if (Whiteflag[y] == 1) continue;
      if (colour[x] == colourkey[y])
	{
	W_peg++;
	Whiteflag[y] = 1;
	break;
	}
      }
    }

  for (x=0;x<B_peg;x++)
    {
    gotoxy(-num_pegs/2+30+x,turns*2+2);
    textcolor(BLUE);
    cputs("\xDD");
    }
  for (y=0;y<W_peg;y++)  // infinite loop
    {
    gotoxy(-num_pegs/2+30+x+y,turns*2+2);
    textcolor(WHITE);
    cputs("\xDD");
    }
  if (B_peg == num_pegs) Won = 1;
  return(Won);
  }

void options(void)
  {
  char key;

  struct textbox Set_Options = { 5, 14, 15, 6, WHITE, BLUE, "(O)ptions", ""};
  make_textbox(Set_Options);
  gotoxy(7,16);
  cputs("Pegs    ( )");
  gotoxy(7,18);
  cputs("Colours ( )");
  key = 'a';
  do
    {
    _setcursortype(_NOCURSOR);
    switch (key)
      {
      case 80:
	global_pegs = (global_pegs>4) ? --global_pegs : 6;
	break;
      case 72:
	global_pegs = (global_pegs<6) ? ++global_pegs : 4;
	break;
      default:
	;
      }
    gotoxy(16,16);
    printf("%d", global_pegs);
    gotoxy(16,16);
    _setcursortype(_NORMALCURSOR);
    }
  while ( ( key=getch()) != '\r' );

key = 'a';
  do
    {
    _setcursortype(_NOCURSOR);
    switch (key)
      {
      case 80:
	global_colours = (global_colours>6) ? --global_colours: 8;
	break;
      case 72:
	global_colours = (global_colours<8) ? ++global_colours: 6;
	break;
      default:
	;
      }
    gotoxy(16,18);
    printf("%d", global_colours);
    gotoxy(16,18);
    _setcursortype(_NORMALCURSOR);
    }
  while ( ( key=getch()) != '\r' );

  _setcursortype(_NOCURSOR);
  struct textbox Restart = { 5, 21, 15, 3, WHITE, BLUE, "","Restart? Y/N"};
  make_textbox(Restart);
  restart = 1;

  do key = getch();
  while (key !='y' && key != 'n' && key != 'Y' && key != 'N');
  if (key == 'n' || key == 'N') restart = 0;
  window(5, 14, 20, 24);
  textbackground(BLUE);
  clrscr();
  window(1,1,80,25);
  make_textbox(Options);
  GoneToOpt = 1;
  }

void show_aboutbox(void)
  {
  int buff3[80][25];
  struct textbox aboutbox =  { 25, 2, 10+num_pegs*(5-1), 22, BLACK, CYAN, " (M)aster Mind ",
			      "" };
  gettext(1,1,80,25,buff3);
  make_textbox(aboutbox);
  window(26, 3, (9+num_pegs*4)+24, 22);
  clrscr();
  gotoxy(-4+num_pegs*2,5);
  cputs("A GAME OF CUNNING");
  gotoxy(-4+num_pegs*2,6);
  cputs("    AND LOGIC");
  gotoxy(1+num_pegs*2,8);
  cputs("COMPUTER");
  gotoxy(num_pegs*2,9);
  cputs("ADAPTATION");
  gotoxy(3+num_pegs*2,10);
  cputs("B Y");
  gotoxy(2+num_pegs*2,11);
  cputs("DAVID");
  gotoxy(2+num_pegs*2,12);
  cputs("SPADY");
  gotoxy(num_pegs*2,14);
  cputs("Copyright");
  gotoxy(1+num_pegs*2,15);
  cputs("1 9 9 4");
  getch();
  puttext(1,1,80,25,buff3);
  window(1,1,80,25);
  }

void show_instructions(void)
  {
    struct textbox Instructions = { 2, 2, 78, 23, BLUE, YELLOW, " Instructions ", ""};
    int buff2[80][25];
    gettext(1,1,80,25,buff2);
    textbackground(BLACK);
    clrscr();
    make_textbox(Instructions);
    window(5,3,76,25);
    textcolor(WHITE);
    cputs("\n*** OBJECT*** \r\n\r\n");
    cputs("The object of mastermind is to guess the order of coloured squares that\n\r");
    cputs("the computer has randomly selected by inputing patterns of colours  and\n\r");
    cputs("receiving clues from the computer in the form of pegs.\n\r\n\r");
    cputs("*** PEGS*** \n\r\n\r");
    cputs("The  computer will award you with one WHITE peg for each square that is\n\r");
    cputs("the correct colour but in the wrong position and one BLACK peg for each\n\r");
    cputs("square that is the correct colour and in the correct position.\n\r\n\r");
    cputs("*** TO PLAY ***\n\r\n\r");
    cputs("Use the  LEFT and RIGHT arrow buttons to  highlight the coloured square\n\r");
    cputs("that is to be changed.  Use the UP and DOWN arrow buttons to change the\n\r");
    cputs("colour of the highlighted square.  Press <<ENTER>> when the squares are\n\r");
    cputs("to your liking.\n\r");

    getch();
    puttext(1,1,80,25,buff2);
    window(1,1,80,25);
    textbackground(BLACK);
  }